"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hookGlobalLog = hookGlobalLog;
exports.log = void 0;

var _support = require("appium/support");

const log = _support.logger.getLogger('DatadogLogPlugin');

exports.log = log;
const gLog = log.unwrap();
const npmToWinstonLevels = {
  silly: 'debug',
  verbose: 'debug',
  debug: 'debug',
  info: 'info',
  http: 'info',
  warn: 'warn',
  error: 'error'
};

function hookGlobalLog(ddLog) {
  if (!gLog) {
    log.error('global npmlog not found.');
    return;
  }

  gLog.on('log', logObj => {
    const winstonLevel = npmToWinstonLevels[logObj.level] || 'info';
    ddLog.log(winstonLevel, {
      component: logObj.prefix,
      message: logObj.message
    });
  });
  log.info('start exporting Appium application logs.');
}